-- type-level natural numbers
data Z		-- zero
data S n	-- successor

-- declares Add abstract class (`user constraint')
class Add a b c

rule Add a b c, Add a b d ==> c = d		-- functional dependency
rule Add Z a b <==> a = b			-- base case
rule Add (S a) b d <==> d = S c, Add a b c	-- recursive case

-- length-indexed lists
data List a b = (b = Z) => Nil
	      | forall b'. (b = S b') => Cons a (List a b')

append :: Add l m n => List a l -> List a m -> List a n
append Nil ys = ys
append (Cons x xs) ys = Cons x (append xs ys)
