-- expressions (abstract)
data Exp = Exp

-- commands
data Cmd p q = forall r. Seq (Cmd p r) (Cmd r q)
	     | ITE Exp (Cmd p q) (Cmd p q)
	     | (p=q) => While Exp (Cmd p q)
	     | Delta p Open  q => OpenF
	     | Delta p Close q => CloseF
	     | Delta p Write q => WriteF

-- automaton states
data S0
data S1

-- alphabet
data Open
data Close
data Write

-- delta function
class Delta a b c

rule Delta a b c, Delta a b d ==> c=d
-- valid transition
rule Delta S0 Open x  <=> x=S1
rule Delta S1 Close x <=> x=S0
rule Delta S1 Write x <=> x=S1

-- improvement
rule Delta x Open y ==> x=S0, y=S1
rule Delta x Close y ==> x=S1, y=S0  -- (Imp)
-- failure
rule Delta S0 Close x ==> S0=S1	-- False
rule Delta S0 Write x ==> S0=S1	
rule Delta S1 Open x  ==> S0=S1	

(>>) = Seq

succeeds = (ITE Exp OpenF (OpenF >> WriteF)) >> WriteF >> CloseF
fails    = succeeds >> WriteF
