
-- type-level natural numbers
data Z		-- zero
data S n	-- successor

class Eq a where
    (==) :: a -> a -> Bool

-- length-indexed lists
data List a b = (b = Z) => Nil
	      | forall b'. (b = S b') => Cons a (List a b')

replace :: Eq a => a -> a -> List a b -> List a b
replace x y xs = 
    let f :: List a c -> List a c
	f Nil = Nil
	f (Cons z xs) = if z == x then Cons y (f xs)
			else Cons z (f xs)
    in  f xs
